;all text in this file copyd from TL3.tl2 file

(define (type           x)        (op  7 x))        ;get type #
(define (eqi            x y)      (op 25 x y))      ;numberic equality

(define op-type       7)
(define op-i2c       12)
(define op-c2i       13)
(define op-null      14)
(define op-car       15)
(define op-cdr       16)
(define op-rplaca    17)
(define op-rplacd    18)
(define op-cons      19)
(define op-vlen      21)
(define op-vref      22)
(define op-vset      23)
(define op-eq        24)
(define op-eqi       25)
(define op-lt        26)
(define op-le        27)
(define op-add       28)
(define op-sub       29)
(define op-mul       30)
(define op-div       31)

(define type-cons     0)
(define type-proc     1)
(define type-fixint   2)
(define type-symbol   3)
(define type-string   4)
(define type-bool     5)
(define type-char     6)
(define type-iport    7)
(define type-oport    8)
(define type-vector   9)

(define-cmacro (type          x)        (list 'op op-type    x))
(define-cmacro (integer->char x)        (list 'op op-i2c     x))
(define-cmacro (char->integer x)        (list 'op op-c2i     x))
(define-cmacro (null?         x)        (list 'op op-null    x))
(define-cmacro (car           c)        (list 'op op-car     c))
(define-cmacro (cdr           c)        (list 'op op-cdr     c))
(define-cmacro (set-car!      c x)      (list 'op op-rplaca  c x))
(define-cmacro (set-cdr!      c x)      (list 'op op-rplacd  c x))
(define-cmacro (cons          x y)      (list 'op op-cons    x y))
(define-cmacro (vector-length v)        (list 'op op-vlen    v))
(define-cmacro (vector-ref    v idx)    (list 'op op-vref    v idx))
(define-cmacro (vector-set!   v idx x)  (list 'op op-vset    v idx x))
(define-cmacro (eq?           x y)      (list 'op op-eq      x y))
(define-cmacro (eqi           x y)      (list 'op op-eqi     x y))

(define-cmacro (pair?        x) (list 'eqi (list 'type x) type-cons))
(define-cmacro (procedure?   x) (list 'eqi (list 'type x) type-proc))
(define-cmacro (number?      x) (list 'eqi (list 'type x) type-fixint))
(define-cmacro (symbol?      x) (list 'eqi (list 'type x) type-symbol))
(define-cmacro (string?      x) (list 'eqi (list 'type x) type-string))
(define-cmacro (boolean?     x) (list 'eqi (list 'type x) type-bool))
(define-cmacro (char?        x) (list 'eqi (list 'type x) type-char))
(define-cmacro (input-port?  x) (list 'eqi (list 'type x) type-iport))
(define-cmacro (output-port? x) (list 'eqi (list 'type x) type-oport))
(define-cmacro (vector?      x) (list 'eqi (list 'type x) type-vector))

(define-cmacro  (not x)   (list 'if x #f #t))

(define-cmacro  (zero? x) (list 'eqi x 0))

(define-cmacro (caar x) (list 'car (list 'car x)))
(define-cmacro (cadr x) (list 'car (list 'cdr x)))
(define-cmacro (cdar x) (list 'cdr (list 'car x)))
(define-cmacro (cddr x) (list 'cdr (list 'cdr x)))

(define (cmacro2 opcode arg rev)
  (if (= (length arg) 2)
    (if rev
     `(op ,opcode ,(cadr arg) ,(car  arg))
     `(op ,opcode ,(car  arg) ,(cadr arg)))
    (punt)))

(define-cmacro (=  . x) (cmacro2 op-eqi x #f))
(define-cmacro (<  . x) (cmacro2 op-lt  x #f))
(define-cmacro (>  . x) (cmacro2 op-lt  x #t))
(define-cmacro (<= . x) (cmacro2 op-le  x #f))
(define-cmacro (>= . x) (cmacro2 op-le  x #t))
(define-cmacro (+  . x) (cmacro2 op-add x #f))
(define-cmacro (-  . x) (cmacro2 op-sub x #f))
(define-cmacro (*  . x) (cmacro2 op-mul x #f))
(define-cmacro (/  . x) (cmacro2 op-div x #f))

(define (cmacro2-char opcode arg rev)
  (if (= (length arg) 2)
    (if rev
     `(op ,opcode (char->integer ,(cadr arg))
                  (char->integer ,(car  arg)))
     `(op ,opcode (char->integer ,(car  arg))
                  (char->integer ,(cadr arg))))
    (punt)))

(define-cmacro (char=?  . x) (cmacro2-char op-eqi x #f))
(define-cmacro (char<?  . x) (cmacro2-char op-lt  x #f))
(define-cmacro (char>?  . x) (cmacro2-char op-lt  x #t))
(define-cmacro (char<=? . x) (cmacro2-char op-le  x #f))
(define-cmacro (char>=? . x) (cmacro2-char op-le  x #t))

