section .text

cycle_push_fixint: ;rbp:fixint_then_cons rdx:intval
  lea     rdi, [H+rbp]
  mov     rax, TYPE_FIXINT
  shl     rax, TYPE_SHIFT
  stosq
  mov     rax, rdx
cycle_stosq_2: ;rbp:2word_then_cons rax:last_word
  stosq
  mov     rax, rbp
  add     rbp, 2*WORD_SIZE
cycle_push_rax: ;rbp:cons rax:car
  lea     rdi, [H+rbp]
  stosq
  mov     rax, S
  stosq
  mov     S, rbp
cycle:
  ;ensure 8 words can always be allocated without gc at start of a cycle
  ;this makes reclaiming a lot of S conses posible cuting ram usage in 3
  mov     rdx, ALLOC_MAX
  add     rdx, F
  sub     rdx, B
  cmp     rdx, N
  ja      nomem
  
decode:
  ;pop c reg and check type
  call    pop_c
  CHECKT  FIXINT, rax, rax, rdi

  ;get op# from cell and check its valid
  add     rax, WORD_SIZE
  mov     rcx, [rax]
  cmp     rcx, OP_N
  jae     eggog_op

  ;goto op
  lea     rax, [op_tab+rcx*2]
  movzx   rax, word [rax]
  add     rax, _op_offset
  jmp     rax

DEF_EGGOG eggog_op, "invalid op"

nomem:
  test    byte [gc_enabled], 1
  jz      eggog_heap
  call    gc
  mov     rdx, ALLOC_MAX
  add     rdx, F
  sub     rdx, B
  cmp     rdx, N
  ja      eggog_heap
  jmp     decode

