section .text

global _start
_start:
  lea     r15, [rdi+8]  ;argv
  mov     r14, [rdi]    ;argc
  jmp     init

%macro DEF_SYSCALL 2 ;label syscall#
%1: ;rdi rsi rdx r10 r8 r9 => rax CLOB rcx
  mov     rax, %2
  syscall
  jnc     .ret
  neg     rax ;emulate linups errno
.ret:
  ret
%endmacro

%macro DEF_SYSCALLP 2 ;label syscall#
%1: ;rdi rsi rdx r10 r8 r9 => rax CLOB rcx
  mov     rax, %2
  push    r8
  push    r9
  push    r10
  push    r11
  syscall
  pop     r11
  pop     r10
  pop     r9
  pop     r8
  jnc     .ret
  neg     rax ;emulate linups errno
.ret:
  ret
%endmacro

;sys/syscall.h
DEF_SYSCALLP  read,     3
DEF_SYSCALLP  write,    4
DEF_SYSCALLP  open,     5
DEF_SYSCALLP  close,    6
DEF_SYSCALL   mmap,   477
DEF_SYSCALL   exit,     1

;fcntl.h
%define O_RDONLY        0x00000000
%define O_WRONLY        0x00000001
%define O_RDWR          0x00000002
%define O_CREAT         0x00000200
%define O_TRUNC         0x00000400

;sys/mman.h
%define PROT_READ       0x00000001
%define PROT_WRITE      0x00000002
%define MAP_PRIVATE     0x00000002
%define MAP_ANONYMOUS   0x00001000

;unistd.h
%define STDIN_FILENO    0
%define STDOUT_FILENO   1
%define STDERR_FILENO   2

%include "inc.s"

