section .text

global _start
_start:
  pop     r14       ;argc
  mov     r15, rsp  ;argv
  jmp     init

%macro DEF_SYSCALL 2 ;label syscall#
%1: ;rdi rsi rdx r10 r8 r9 => rax CLOB rcx
  mov     rax, %2
  push    r11
  syscall
  pop     r11
  ret
%endmacro

;asm/unistd_64.h
DEF_SYSCALL read,       0
DEF_SYSCALL write,      1
DEF_SYSCALL open,       2
DEF_SYSCALL close,      3
DEF_SYSCALL mmap,       9
DEF_SYSCALL exit,      60

;bits/fcntl-linux.h
%define O_RDONLY        0x00000000
%define O_WRONLY        0x00000001
%define O_RDWR          0x00000002
%define O_CREAT         0x00000040
%define O_TRUNC         0x00000200

;bits/mman-linux.h
%define PROT_READ       0x00000001
%define PROT_WRITE      0x00000002
%define MAP_PRIVATE     0x00000002
%define MAP_ANONYMOUS   0x00000020

;unistd.h
%define STDIN_FILENO    0
%define STDOUT_FILENO   1
%define STDERR_FILENO   2

%include "inc.s"

